
#property copyright "http://dmffx.com"
#property link      "http://dmffx.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DarkGray
#property indicator_color2 Red
#property indicator_color3 Yellow

//---- input parameters
extern string TimeFrame = "Current time frame";
extern   int      ForcePeriod=14;
extern   int      ForceMethod=0;
extern   int      ForcePrice=0;
extern   int      ForceShift=0; 
extern   int      SmPeriod=14;
extern   int      SmMethod=0;
extern   int      SmShift=0; 
extern   int      SgPeriod=14;
extern   int      SgMethod=0;
extern   int      SgShift=0;
extern   double   Level_1_Value=5;
extern   double   Level_2_Value=10;
extern   double   Level_3_Value=15;      
extern   color    Level_1_Color=RoyalBlue;
extern   color    Level_2_Color=Green;
extern   color    Level_3_Color=Chocolate;   
extern   bool     TesterMode=false; 

//---- buffers
double source[];
double main[];
double signal[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;
string ShortName;
string InIndexLabelName="DS Force";
string ObjPref="DS_Force";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,source);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,main);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,signal);   
   
   
      
   IndicatorDigits(2);
   
   
   SetIndexDrawBegin(0,ForcePeriod);
   SetIndexDrawBegin(1,ForcePeriod+fMADrawBegin(SmPeriod,SmMethod));  
   SetIndexDrawBegin(2,ForcePeriod+fMADrawBegin(SmPeriod,SmMethod)+fMADrawBegin(SgPeriod,SgMethod)); 
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   SetIndexShift(0,ForceShift                 * timeFrame/Period());  
   SetIndexShift(1,ForceShift+SmShift         * timeFrame/Period());  
   SetIndexShift(2,ForceShift+SmShift+SgShift * timeFrame/Period());            
   
   SetIndexLabel(0,InIndexLabelName+" Source");
   SetIndexLabel(1,InIndexLabelName+" Main");   
   SetIndexLabel(2,InIndexLabelName+" Signal");
   ShortName = timeFrameToString(timeFrame)+"  DS Force";
   IndicatorShortName(ShortName);
   return(0);
  }
int fMADrawBegin(int aPeriod,int aMethod){
      switch(aMethod){
         case 1: return(10*aPeriod);
         case 2: return(20*aPeriod);      
      }
   return(aPeriod);    
}
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
      fObjDeleteByPrefix(ObjPref);
//----
   return(0);
  }
void fObjDeleteByPrefix(string aPrefix){
   for(int i=ObjectsTotal()-1;i>=0;i--){
      if(StringFind(ObjectName(i),aPrefix,0)==0){
         ObjectDelete(ObjectName(i));
      }
   }
}
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { source[0] = limit+1; return(0); }
         if (timeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  source[i] = iCustom(NULL,timeFrame,indicatorFileName,"",ForcePeriod,ForceMethod,ForcePrice,ForceShift,SmPeriod,SmMethod,SmShift,
                              SgPeriod,SgMethod,SgShift,Level_1_Value,Level_2_Value,Level_3_Value,Level_1_Color,Level_2_Color,Level_3_Color,TesterMode,0,y);
                  main[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",ForcePeriod,ForceMethod,ForcePrice,ForceShift,SmPeriod,SmMethod,SmShift,
                              SgPeriod,SgMethod,SgShift,Level_1_Value,Level_2_Value,Level_3_Value,Level_1_Color,Level_2_Color,Level_3_Color,TesterMode,1,y);
                  signal[i] = iCustom(NULL,timeFrame,indicatorFileName,"",ForcePeriod,ForceMethod,ForcePrice,ForceShift,SmPeriod,SmMethod,SmShift,
                              SgPeriod,SgMethod,SgShift,Level_1_Value,Level_2_Value,Level_3_Value,Level_1_Color,Level_2_Color,Level_3_Color,TesterMode,2,y);
            }
            return(0);                
         }


            for( i=limit-1;i>=0;i--){
               source[i]=iForce(NULL,0,ForcePeriod,ForceMethod,ForcePrice,i);
            }
            for(i=limit-1;i>=0;i--){
               main[i]=iMAOnArray(source,0,SmPeriod,0,SmMethod,i);
            }            
            for(  i=limit-1;i>=0;i--){
               signal[i]=iMAOnArray(main,0,SgPeriod,0,SgMethod,i);
            } 
            if(TesterMode){
               return(0);
            }
         fObjHLine(ObjPref+"_1p",Level_1_Value,Level_1_Color,1,WindowFind(ShortName),2,true);
         fObjHLine(ObjPref+"_2p",Level_2_Value,Level_2_Color,1,WindowFind(ShortName),2,true);           
         fObjHLine(ObjPref+"_3p",Level_3_Value,Level_3_Color,1,WindowFind(ShortName),2,true); 
         fObjHLine(ObjPref+"_1m",-Level_1_Value,Level_1_Color,1,WindowFind(ShortName),2,true);
         fObjHLine(ObjPref+"_2m",-Level_2_Value,Level_2_Color,1,WindowFind(ShortName),2,true);           
         fObjHLine(ObjPref+"_3m",-Level_3_Value,Level_3_Color,1,WindowFind(ShortName),2,true);  
         
        
                            
   return(0);
  }
//+------------------------------------------------------------------+

void fObjHLine(
   string aObjectName,  // 1 
   double aPrice_1,     // 2 
   color aColor=Red,    // 3 
   int aWidth=1,        // 4 
   int aWindowNumber=0, // 5 
   int aStyle=0,        // 6 0-STYLE_SOLID, 1-STYLE_DASH, 2-STYLE_DOT, 3-STYLE_DASHDOT, 4-STYLE_DASHDOTDOT
   bool aBack=false     // 7 
   ){
   
   // fHLine("",Close[1]);
   // fHLine("",Close[1],Red,1,0,STYLE_SOLID,false);
   
      if(ObjectFind(aObjectName)!=aWindowNumber){
         ObjectCreate(aObjectName,OBJ_HLINE,aWindowNumber,0,aPrice_1);
      }      
   ObjectSet(aObjectName,OBJPROP_PRICE1,aPrice_1);   
   ObjectSet(aObjectName,OBJPROP_COLOR,aColor);
   ObjectSet(aObjectName,OBJPROP_WIDTH,aWidth);
   ObjectSet(aObjectName,OBJPROP_BACK,aBack);   
   ObjectSet(aObjectName,OBJPROP_STYLE,aStyle);            
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

